import type {
  TableColumn,
  TableColumnInGroup,
} from '../components/ColumnSet/index.vue'
import type { CSSProperties } from 'vue'

type CellSlotProps = {
  column: TableColumn | TableColumnInGroup
  columns: TableColumn[] | TableColumnInGroup[]
  columnIndex: number
  depth: number
  style: CSSProperties
  rowData: any
  rowIndex: number
  isScrolling: boolean
  expandIconProps?:
    | {
        rowData: any
        rowIndex: number
        onExpand: (expand: boolean) => void
      }
    | undefined
}

export default function useTableCellClick() {
  const router = useRouter()
  const route = useRoute()
  const cellClickHandler = ({ column, rowData }: CellSlotProps) => {
    switch (column.dataKey) {
      case 'flightNO':
        router.push({
          path: `${route.path.split('/').slice(0, -1).join('/')}/flight`,
          query: {
            flightNO: rowData.flightNO,
            flightDate: rowData.flightDate,
          },
        })
        break
      default:
        break
    }
  }

  return {
    cellClickHandler,
  }
}
